Index: tmp/org.txm.core/src/java/org/txm/importer/PartialDomIdentityParser.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/PartialDomIdentityParser.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/PartialDomIdentityParser.groovy	(revision 881)
@@ -0,0 +1,179 @@
+package org.txm.importer
+
+import java.util.ArrayList;
+
+import javax.xml.stream.XMLStreamConstants;
+import javax.xml.stream.XMLOutputFactory;
+import javax.xml.stream.XMLStreamWriter;
+
+import java.io.File;
+import java.io.Writer;
+import java.net.URL;
+
+import javax.xml.stream.*;
+
+class PartialDomIdentityParser extends StaxIdentityParser {
+	
+	boolean domMode = false;
+	def partialDom = [];
+	def currentNode;
+	
+	public PartialDomIdentityParser(File infile) {
+		super(infile)
+	}
+	
+	protected void processNamespace() {
+		super.processNamespace()
+	}
+	
+	protected void processStartElement()
+	{
+		if (parser.getLocalName() == "test") {
+			println "Build dom..."
+			Tag testTag = new Tag(parser);
+			println testTag.toString()
+			testTag.writeDom(writer)
+		} else {
+			super.processStartElement()
+		}
+	}
+	
+	protected void writeAttributes() {
+		super.writeAttributes();
+	}
+	
+	protected void processCharacters()
+	{
+		super.processCharacters()
+	}
+	
+	protected void processProcessingInstruction()
+	{
+		super.processProcessingInstruction()
+	}
+	
+	protected void processDTD()
+	{
+		super.processDTD()
+	}
+	
+	protected void processCDATA()
+	{
+		super.processCDATA();
+	}
+	
+	protected void processComment()
+	{
+		super.processComment()
+	}
+	
+	protected void processEndElement()
+	{
+		super.processEndElement();
+	}
+	
+	protected void processEndDocument() {
+		super.processEndDocument()
+	}
+	
+	protected void processEntityReference() {
+		super.processEntityReference()
+	}
+	
+	public class Tag {
+		public String[] attnames, attvalues, attprefix;
+		public String localname, prefix
+		int count;
+		public def children = [];
+
+		public Tag(def parser) {
+			prefix = parser.getPrefix()
+			localname = parser.getLocalName();
+			count = parser.getAttributeCount()
+			attnames =  new String[count]
+			attvalues = new String[count]
+			attprefix = new String[count]
+			for (int i = 0 ; i < count ; i++) {
+				attnames[i] = parser.getAttributeLocalName(i)
+				attprefix[i] = parser.getAttributePrefix(i).toString()
+				attvalues[i] = parser.getAttributeValue(i).toString()
+			}
+			buildNodeContent(parser)
+		}
+		
+		private void buildNodeContent(def parser) {
+			try {
+				for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+					//println "event "+event
+					switch (event) {
+						case XMLStreamConstants.START_ELEMENT:
+							children << new Tag(parser);
+							break;
+						case XMLStreamConstants.CHARACTERS:
+							children << parser.getText()
+							break;
+						case XMLStreamConstants.END_ELEMENT:
+							if (localname == parser.getLocalName()) {
+								return; // end of stax parsing, the Tag is built
+							}
+							break;
+						case XMLStreamConstants.END_DOCUMENT:
+							println "ERROR: END OF DOCUMENT REACHED"
+							break;
+					}
+				}
+			} catch(Exception e) {
+				println("Error while parsing partial content of file "+inputurl);
+				println("Location "+parser.getLocation());
+				org.txm.utils.logger.Log.printStackTrace(e);
+				return;
+			}
+		}
+
+		public String toString() {
+			def out = new StringWriter()
+			XMLStreamWriter strwriter = outfactory.createXMLStreamWriter(out);//create a new file
+			println ""+(strwriter != null)
+			writeDom(strwriter);
+			return out.toString()
+		}
+		
+		public writeDom(def writer) {
+			// Open the Tag
+			if (prefix != null && prefix.length() > 0)
+				writer.writeStartElement(prefix+":"+localname)
+			else
+				writer.writeStartElement(localname)
+
+			// write Attributes
+			for (int i = 0 ; i < count ; i++) {
+				if (attprefix[i] != null && attprefix[i].length() > 0) {
+					writer.writeAttribute(attprefix[i]+":"+attnames[i], attvalues[i])
+				} else {
+					writer.writeAttribute(attnames[i], attvalues[i])
+				}
+			}
+			
+			// write children recursivelly
+			for (def child : children) {
+				if (child instanceof String) {
+					writer.writeCharacters(child)
+				} else if (child instanceof Tag) {
+					child.writeDom(writer)
+				} else {
+					println "Error: can't write $child"
+				}
+			}
+			
+			// close the Tag
+			writer.writeEndElement() 
+		}
+	}
+	
+	public static void main(String[] args) {
+		File infile = new File("/home/mdecorde/xml/partialdom/test.xml")
+		File outfile = new File("/home/mdecorde/xml/partialdom/test-o.xml")
+		PartialDomIdentityParser p = new PartialDomIdentityParser(infile);
+		println p.process(outfile)
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/SetNewXmlDocumentRoot.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/SetNewXmlDocumentRoot.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/SetNewXmlDocumentRoot.groovy	(revision 881)
@@ -0,0 +1,51 @@
+package org.txm.importer
+
+import java.io.File;
+
+import org.w3c.dom.Document;
+import java.io.File;
+
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.Node;
+
+import javax.xml.parsers.*;
+import javax.xml.xpath.*;
+import javax.xml.transform.*;
+import javax.xml.transform.dom.DOMSource;
+import javax.xml.transform.stream.StreamResult;
+import org.txm.importer.PersonalNamespaceContext;
+
+class SetNewXmlDocumentRoot {
+	public static boolean process(File xmlfile, String xpath) {
+		DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
+		domFactory.setNamespaceAware(true); // never forget this!
+		domFactory.setXIncludeAware(true);
+		DocumentBuilder builder = domFactory.newDocumentBuilder();
+		
+		Document doc = builder.parse(xmlfile);
+		Element root = doc.getDocumentElement();
+		
+		XPathFactory xpathfactory = XPathFactory.newInstance();
+		def _xpath = xpathfactory.newXPath();
+		_xpath.setNamespaceContext(new PersonalNamespaceContext());
+		def expr = _xpath.compile(xpath);
+		def nodes = expr.evaluate(doc, XPathConstants.NODESET);
+
+		for(Node node : nodes) {
+
+			Document document = builder.newDocument();
+			document.setXmlVersion("1.0");
+			document.setXmlStandalone(true);
+			Node adopted = document.adoptNode(node)
+			document.appendChild(adopted)
+			return org.txm.utils.xml.DomUtils.save(document, xmlfile);
+		}
+		return false;
+	}
+	
+	//		File xmlfile = new File("/home/mdecorde/xml/txmrefman/TEI/refman.xml")
+	//		File outfile = new File("/home/mdecorde/xml/txmrefman/TEI/refman-o.xml")
+	//		String xpath = "//body"
+	
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/ReadImportParameters.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/ReadImportParameters.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/ReadImportParameters.groovy	(revision 881)
@@ -0,0 +1,277 @@
+package org.txm.importer
+
+import javax.xml.stream.*;
+import java.net.URL;
+/**
+ * Read the import.xml file
+ * @author mdecorde
+ */
+class ReadImportParameters {
+	HashMap<String, ArrayList<String>> links = new HashMap<String, ArrayList<String>>();;
+	HashMap<String, String> structs = new HashMap<String, String>();
+	HashMap<String, Integer> levels = new HashMap<String, Integer>();
+	
+	HashMap<String, HashMap<String, String>> metadatas = [:];
+	HashMap<String, HashMap<String, String>> pattributes = [:];
+	HashMap<String, HashMap<String, String>> sattributes = [:];
+	
+	HashMap<String, String> biblios = [:];
+	
+	HashMap<String, String> uis = [:];
+	
+	HashMap<String, ArrayList<HashMap<String, String>>> editions = [:];
+	
+	String basename;
+	String encoding;
+	String language;
+	String rootDir;
+	String script;
+	String xslt;
+	String author;
+	String description;
+	
+	boolean debug;
+
+	public ReadImportParameters()
+	{
+
+	}
+
+	public boolean read(File infile)
+	{
+		try {
+			def url = infile.toURI().toURL();
+			def inputData = url.openStream();
+			def factory = XMLInputFactory.newInstance();
+			def parser = factory.createXMLStreamReader(inputData);
+			return read(parser);
+		} catch (XMLStreamException ex) {
+			System.out.println(ex);
+		}catch (IOException ex) {
+			System.out.println("IOException while parsing ");
+		}
+	}
+
+	public boolean read(def parser)
+	{
+		boolean startAlignInfos = false;
+		boolean startEditions = false;
+		boolean startMetadatas = false;
+		boolean startPAttributes = false;
+		boolean startSAttributes = false;
+		boolean startTokenizer = false;
+		
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next())
+		{
+			switch (event) {
+
+				case XMLStreamConstants.END_ELEMENT:
+					String localname = parser.getLocalName();
+					if(localname == "linkGrp")
+					{
+						startAlignInfos = false;
+					}
+					else if(localname == "metadatas")
+					{
+						startMetadatas = false;
+					}
+					else if(localname == "editions")
+					{
+						startEditions = false;
+					}
+					else if(localname == "pattributes")
+					{
+						startPAttributes = false;
+					}
+					else if(localname == "sattributes")
+					{
+						startSAttributes = false;
+					}
+					else if(localname == "tokenizer")
+					{
+						startSAttributes = false;
+					}
+					break;
+
+				case XMLStreamConstants.START_ELEMENT:
+					String localname = parser.getLocalName();
+					if (localname == "import")
+					{
+						basename = parser.getAttributeValue(null, "name");
+						encoding = parser.getAttributeValue(null, "encoding");
+						language = parser.getAttributeValue(null, "lang");
+						rootDir = parser.getAttributeValue(null, "rootDir");
+						script = parser.getAttributeValue(null, "script");
+						xslt = parser.getAttributeValue(null, "xslt");
+						author = parser.getAttributeValue(null, "author")
+						description = parser.getAttributeValue(null, "desc");
+						
+						boolean debug;
+					}
+					else if(localname == "editions")
+					{
+						startEditions = true;
+					}
+					else if(localname == "edition")
+					{
+						String corpus = parser.getAttributeValue(null, "corpus")
+						if(!editions.containsKey(corpus))
+							editions.put(corpus, []);
+						def list = editions.get(corpus);
+						def map = [:]
+						list.add(map)
+						
+						map.put("name", parser.getAttributeValue(null, "name"))
+						map.put("mode", parser.getAttributeValue(null, "mode"))
+						map.put("script", parser.getAttributeValue(null, "script"))
+					}
+					else if (localname == "metadatas") {
+						startMetadatas = true;
+					}
+					else if (localname == "metadata" && startMetadatas) {
+						metadatas.put(parser.getAttributeValue(null, "id"), 
+							["id":parser.getAttributeValue(null, "id"),
+							"shortname":parser.getAttributeValue(null, "shortname"),
+							"longname":parser.getAttributeValue(null, "longname"),
+							"type":parser.getAttributeValue(null, "type"),
+							"selection":parser.getAttributeValue(null, "selection"),
+							"partition":parser.getAttributeValue(null, "partition"),
+							"display":parser.getAttributeValue(null, "display"),])
+					}
+					else if (localname == "pattributes") {
+						startPAttributes = true;
+					} else if(localname == "pattribute" && startPAttributes) {
+						pattributes.put(parser.getAttributeValue(null, "id"), 
+							["id":parser.getAttributeValue(null, "id"),
+							"shortname":parser.getAttributeValue(null, "shortname"),
+							"longname":parser.getAttributeValue(null, "longname"),
+							"type":parser.getAttributeValue(null, "type"),
+							"renderer":parser.getAttributeValue(null, "renderer"),
+							"tooltip":parser.getAttributeValue(null, "tooltip"),
+							"display":parser.getAttributeValue(null, "display"),
+							"min":parser.getAttributeValue(null, "min"),
+							"max":parser.getAttributeValue(null, "max"),
+							"inputFormat":parser.getAttributeValue(null, "inputFormat"),
+							"outputFormat":parser.getAttributeValue(null, "outputFormat"),
+							"position":parser.getAttributeValue(null, "position"),
+							"sortBy":parser.getAttributeValue(null, "sortBy")])
+					}
+					else if (localname == "sattributes") {
+						startSAttributes = true;
+					}
+					else if (localname == "sattribute" && startSAttributes) {
+						sattributes.put(parser.getAttributeValue(null, "id"), 
+							["id":parser.getAttributeValue(null, "id"),
+							"shortname":parser.getAttributeValue(null, "shortname"),
+							"longname":parser.getAttributeValue(null, "longname"),
+							"type":parser.getAttributeValue(null, "type"),
+							"renderer":parser.getAttributeValue(null, "renderer"),
+							"tooltip":parser.getAttributeValue(null, "tooltip"),
+							"pattern":parser.getAttributeValue(null, "renderer"),
+							"import":parser.getAttributeValue(null, "import"),
+							"min":parser.getAttributeValue(null, "min"),
+							"max":parser.getAttributeValue(null, "max"),
+							"mandatory":parser.getAttributeValue(null, "mandatory"),
+							"order":parser.getAttributeValue(null, "order"),
+							"inputFormat":parser.getAttributeValue(null, "inputFormat"),
+							"outputFormat":parser.getAttributeValue(null, "outputFormat"),])
+					} else if (localname == "link" && startAlignInfos) {
+						String target = parser.getAttributeValue(null, "target");
+						String struct = parser.getAttributeValue(null, "alignElement");
+						String level = parser.getAttributeValue(null, "alignLevel")
+						ArrayList<String> corpora = target.split("#");
+						for (int i = 0 ; i < corpora.size() ; i++) {
+							corpora[i] = corpora[i].trim()
+							if (corpora[i].length() == 0) {
+								corpora.remove(i)
+								i--
+							}
+						}
+
+						if (level == null)
+							level = "1";
+
+						if (corpora.size() == 0) {
+							println "no corpus aligned: "+parser.getLocation()
+							return false;
+						}
+						if (struct == null) {
+							println "a sturcture is missing: "+parser.getLocation()
+							return false;
+						}
+						links.put(target, corpora)
+						structs.put(target, struct)
+						levels.put(target, level.toInteger())
+					} else if(localname == "linkGrp" && parser.getAttributeValue(null, "type") == "align") {
+						startAlignInfos = true;
+					} else if(localname == "tokenizer") {
+						startSAttributes = true;
+					}
+			}
+		}
+	}
+
+	public Set<String> getAlignements()
+	{
+		return links.keySet();
+	}
+
+	public ArrayList<String> getTargets(String alignement)
+	{
+		return links.get(alignement);
+	}
+
+	public String getStructure(String alignement)
+	{
+		return structs.get(alignement);
+	}
+
+	public int getLevel(String alignement)
+	{
+		return levels.get(alignement);
+	}
+
+	public void dump()
+	{
+		println "LINKS"
+		for(String link : links.keySet())
+		{
+			println link
+			println " corpus: "+links.get(link)
+			println " struct: "+structs.get(link)
+			println " level: "+levels.get(link)
+		}
+		
+		println "PROPERTIES"
+		println "metadatas $metadatas"
+		println " pattributes $pattributes"
+		println " sattributes $sattributes"
+		
+		println " biblios $biblios"
+		
+		println "uis $uis"
+		
+		println " editions $editions"
+		
+		println "HEADER"
+		println " basename $basename"
+		println " encoding $encoding"
+		println " language $language"
+		println " rootDir $rootDir"
+		println " script $script"
+		println " xslt $xslt"
+		println " author $author"
+		println " description $description"
+		println "DEBUG: $debug"
+	}
+
+	public static void main(String[] args)
+	{
+		String userhome = System.getProperty("user.home");
+		File alignfile = new File(userhome, "xml/xmltxmpara/align.xml")
+		ReadImportParameters parameters = new ReadImportParameters();
+		parameters.read(alignfile);
+		parameters.dump();
+	}
+}
+
Index: tmp/org.txm.core/src/java/org/txm/importer/MileStoneProjection.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/MileStoneProjection.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/MileStoneProjection.groovy	(revision 881)
@@ -0,0 +1,110 @@
+package org.txm.importer
+
+import java.io.File;
+import javax.xml.stream.XMLStreamConstants;
+import javax.xml.stream.XMLOutputFactory;
+import javax.xml.stream.XMLStreamWriter;
+import java.net.URL;
+import javax.xml.stream.*;
+import org.txm.importer.filters.*;
+import org.txm.importer.PersonalNamespaceContext;
+
+/**
+ * add 2 attributes per element to encode the distance to the previous milestone and next milestone
+ * TODO: only the first attribute is implemented
+ * 
+ * @author mdecorde
+ *
+ */
+class MileStoneProjection extends StaxIdentityParser {
+	String wordTag
+	String mileStoneTag
+	String startTag
+	boolean start = false
+
+	int mileStoneDistance = 0
+
+	String mileStoneID = ""
+	def milestonesLength = []
+	int milestonesCounter = 0
+	boolean secondPass = false
+	
+	String msIdAttributeName
+	String msStartAttributeName
+	String msEndAttributeName
+
+	public MileStoneProjection(File inputFile, String startTag, String wordTag, String mileStoneTag) {
+		super(inputFile)
+
+		this.wordTag = wordTag
+		this.mileStoneTag = mileStoneTag
+		mileStoneID = mileStoneTag+"_0"
+		this.startTag = startTag
+		this.start = false;
+		
+		msIdAttributeName = mileStoneTag+"id";
+		msStartAttributeName = mileStoneTag+"start";
+		msEndAttributeName = mileStoneTag+"end";
+
+		fetchMilestoneLengths();
+		start = false // reset
+	}
+
+	public void fetchMilestoneLengths() {
+		def inputData = inputurl.openStream();
+		def factory = XMLInputFactory.newInstance();
+		def parser = factory.createXMLStreamReader(inputData);
+
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+			switch (event) {
+				case XMLStreamConstants.START_ELEMENT:
+					localname = parser.getLocalName()
+					if (start && localname == mileStoneTag) {
+						milestonesLength << mileStoneDistance;
+						mileStoneDistance = 0
+						milestonesCounter++;
+					} else if (start && localname == wordTag) {
+						mileStoneDistance++
+					} else if (localname == startTag) {
+						start = true
+					}
+					break;
+			}
+		}
+		milestonesLength[milestonesCounter] = mileStoneDistance;
+		parser.close()
+		milestonesCounter = 0;
+	}
+
+
+	
+	public void processStartElement() {
+		super.processStartElement();
+
+		if (start && localname == mileStoneTag) {
+			mileStoneDistance = 0
+			mileStoneID = parser.getAttributeValue(null, "id")
+			if (mileStoneID == null) mileStoneID = parser.getAttributeValue("xml", "id");
+			if (mileStoneID == null) mileStoneID = "0";
+			
+			milestonesCounter++;
+		} else if (start && localname == wordTag) {
+			// println "end of $milestonesCounter len="+milestonesLength[milestonesCounter]+" dist="+mileStoneDistance
+			writer.writeAttribute(msEndAttributeName, Integer.toString((milestonesLength[milestonesCounter] - mileStoneDistance - 1)))
+			writer.writeAttribute(msStartAttributeName, Integer.toString(mileStoneDistance))
+			writer.writeAttribute(msIdAttributeName, mileStoneID)
+
+			mileStoneDistance++
+		} else if (localname == startTag) {
+			start = true
+		}
+	}
+
+	public static void main(String[] args) {
+		File inputFile = new File("/home/mdecorde/TXM/corpora/BVHEPISTEMON2016/tokenized/1538_MarotAdole.xml")
+		File outputFile = new File("/home/mdecorde/TEMP/tmp.xml")
+
+		MileStoneProjection msp = new MileStoneProjection(inputFile, "body", "w", "lb");
+		println "Sucess: "+msp.process(outputFile)
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/StaxParser.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/StaxParser.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/StaxParser.groovy	(revision 881)
@@ -0,0 +1,165 @@
+package org.txm.importer
+
+import groovy.transform.CompileStatic
+import java.io.File;
+import javax.xml.stream.XMLStreamConstants;
+import javax.xml.stream.XMLOutputFactory;
+import javax.xml.stream.XMLStreamWriter;
+import java.net.URL;
+import javax.xml.stream.*;
+import org.txm.importer.filters.*;
+import org.txm.importer.PersonalNamespaceContext;
+
+@CompileStatic
+class StaxParser {
+
+	protected URL inputurl;
+	protected InputStream inputData;
+	protected XMLInputFactory factory;
+	protected XMLStreamReader parser;
+	
+	
+	protected static PersonalNamespaceContext Nscontext = new PersonalNamespaceContext();
+	
+	protected String localname;
+	
+	public StaxParser(File infile)
+	{
+		this(infile.toURI().toURL());
+	}
+	
+	public StaxParser(URL inputurl)
+	{
+		this.inputurl = inputurl;
+		inputData = inputurl.openStream();
+		factory = XMLInputFactory.newInstance();
+		
+		parser = factory.createXMLStreamReader(inputData);
+	}
+	
+	protected void before()
+	{
+		
+	}
+	
+	protected void after()
+	{
+		factory = null;
+		if (parser !=null) parser.close();
+		parser = null;
+	}
+	
+	protected void closeForError() {
+		parser.close();
+	}
+
+	public boolean process()
+	{
+		try {
+			for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+				switch (event) {
+					case XMLStreamConstants.NAMESPACE:
+						processNamespace();
+						break;
+					case XMLStreamConstants.START_ELEMENT:
+						localname = parser.getLocalName();
+						processStartElement();
+						break;		
+					case XMLStreamConstants.CHARACTERS:
+						processCharacters();
+						break;
+					case XMLStreamConstants.PROCESSING_INSTRUCTION:
+						processProcessingInstruction();
+						break;
+					case XMLStreamConstants.DTD:
+						processDTD();
+						break;
+					case XMLStreamConstants.CDATA:
+						processCDATA();
+						break;
+					case XMLStreamConstants.COMMENT:
+						processComment();
+						break;
+					case XMLStreamConstants.END_ELEMENT:
+						localname = parser.getLocalName();
+						processEndElement();	
+						break;
+					case XMLStreamConstants.END_DOCUMENT:
+						processEndDocument();
+						break;
+					case XMLStreamConstants.ENTITY_REFERENCE:
+						processEntityReference();
+						break;
+				}
+			}
+		} catch(Exception e) {
+			println("Unexpected error while parsing file "+inputurl+" : "+e);
+			println("Location line: "+parser.getLocation().getLineNumber()+" character: "+parser.getLocation().getColumnNumber());
+			org.txm.utils.logger.Log.printStackTrace(e);
+			parser.close();
+			return false;
+		}
+		
+		after(); // if you need to do something before closing the parser();
+		return true;
+	}
+
+	public def getLocation() {
+		if (parser != null)
+			return "Line: "+parser.getLocation().getLineNumber()+" Col: "+parser.getLocation().	getColumnNumber()
+		return null;
+	}
+	
+	protected void processNamespace() {
+	}
+	
+	protected void processStartElement()
+	{
+	}
+
+	protected void processCharacters()
+	{
+	}
+	
+	protected void processProcessingInstruction()
+	{
+	}
+	
+	protected void processDTD()
+	{
+	}
+	
+	protected void processCDATA()
+	{
+	}
+	
+	protected void processComment()
+	{
+	}
+	
+	protected void processEndElement()
+	{
+	}
+	
+	protected void processEndDocument() {
+	}
+	
+	protected void processEntityReference() {
+	}
+	
+	public static void main(String[] args)
+	{
+		File input = new File("/home/mdecorde/xml/xiinclude/master.xml")
+		File output = new File("/home/mdecorde/xml/xiinclude/merged.xml")
+		if (!(input.exists() && input.canRead())) {
+			println "cannot found $input";
+			return;
+		}
+		def builder = new StaxParser(input.toURI().toURL());
+		if (builder.process()) {
+			println "success ? "+ValidateXml.test(output);
+		} else {
+			println "failure !"
+		}
+	}
+}
\ No newline at end of file
Index: tmp/org.txm.core/src/java/org/txm/importer/StaxStackWriter.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/StaxStackWriter.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/StaxStackWriter.groovy	(revision 881)
@@ -0,0 +1,259 @@
+package org.txm.importer
+
+import java.nio.charset.Charset;
+
+import javax.xml.namespace.NamespaceContext;
+import javax.xml.stream.*;
+
+import org.eclipse.core.runtime.Platform;
+
+public class StaxStackWriter implements XMLStreamWriter {
+
+	XMLStreamWriter writer;
+	OutputStream output;
+	def events = [];
+	
+	public StaxStackWriter(File file) {
+		this(new BufferedOutputStream(new FileOutputStream(file)));
+	}
+	
+	public StaxStackWriter(File file, String encoding) {
+		this(new BufferedOutputStream(new FileOutputStream(file)), encoding);
+	}
+	
+	public StaxStackWriter(OutputStream output) {
+		this(output, "UTF-8");//create a new file
+	}
+	
+	public StaxStackWriter(OutputStream output, String encoding) {
+		XMLOutputFactory factory = XMLOutputFactory.newInstance();
+		this.output = output
+		this.writer = factory.createXMLStreamWriter(output, encoding);//create a new file
+	}
+
+	Charset UTF8 = Charset.forName("UTF-8");
+	public void write(String txt) {
+		output.write(txt.getBytes(UTF8))
+	}
+	
+	public void writeEndElements() {
+		int size = events.size();
+		for (int i = 0 ; i < size ; i++) {
+			writeEndElement();
+		}
+		events = [];
+	}
+
+	public void writeStartElements(def tagsToWrite) {
+		for (String tag : tagsToWrite)
+			writeStartElement(tag);
+	}
+
+	public def getTagStack() {
+		return events;
+	}
+
+	@Override
+	public void close () throws XMLStreamException {
+		writer.close();
+		output.close();
+	}
+
+	@Override
+	public void flush () throws XMLStreamException {
+		writer.flush();
+
+	}
+
+	@Override
+	public NamespaceContext getNamespaceContext() {
+		return writer.getNamespaceContext();
+	}
+
+	@Override
+	public String getPrefix (String uri) throws XMLStreamException {
+		return writer.getPrefix(uri);
+	}
+
+	@Override
+	public Object getProperty (String name) throws IllegalArgumentException {
+		return writer.getProperty(name);
+	}
+
+	@Override
+	public void setDefaultNamespace (String uri) throws XMLStreamException {
+		writer.setDefaultNamespace(uri);
+	}
+
+	@Override
+	public void setNamespaceContext(NamespaceContext context)
+	throws XMLStreamException {
+		writer.setNamespaceContext(context);
+	}
+
+	@Override
+	public void setPrefix (String prefix, String uri) throws XMLStreamException {
+		writer.setPrefix(prefix, uri);
+	}
+
+	@Override
+	public void writeAttribute (String localName, String value) throws XMLStreamException {
+		writer.writeAttribute(localName, value);
+	}
+
+	@Override
+	public void writeAttribute (String namespaceURI, String localName, String value) throws XMLStreamException {
+		writer.writeAttribute(namespaceURI, localName, value);
+	}
+
+	@Override
+	public void writeAttribute (String prefix, String namespaceURI, String localName, String value) throws XMLStreamException {
+		writer.writeAttribute(prefix, namespaceURI, localName, value);
+	}
+
+	@Override
+	public void writeCData (String data) throws XMLStreamException {
+		writer.writeCData(data);
+	}
+
+	@Override
+	public void writeCharacters (String text) throws XMLStreamException {
+		writer.writeCharacters(text);
+	}
+
+	@Override
+	public void writeCharacters (char[] text, int start, int len) throws XMLStreamException {
+		writer.writeCharacters(text, start, len);
+	}
+
+	@Override
+	public void writeComment (String data) throws XMLStreamException {
+		writer.writeComment(data);
+	}
+
+	@Override
+	public void writeDTD (String dtd) throws XMLStreamException {
+		writer.writeDTD(dtd);
+	}
+
+	@Override
+	public void writeDefaultNamespace(String namespaceURI)
+	throws XMLStreamException {
+		writer.writeDefaultNamespace(namespaceURI);
+	}
+
+	public void writeElement (String localName, String text) throws XMLStreamException {
+		writer.writeStartElement(localName);
+		writer.writeCharacters(text);
+		writer.writeEndElement();
+	}
+	
+	public void writeElement (String localName, def map, String text) throws XMLStreamException {
+		writer.writeStartElement(localName);
+		for (def key : map.keySet()) writeAttribute(key.toString(), map[key].toString());
+		writer.writeCharacters(text);
+		writer.writeEndElement();
+	}
+
+	@Override
+	public void writeEmptyElement (String localName) throws XMLStreamException {
+		writer.writeEmptyElement(localName);
+	}
+
+	public void writeEmptyElement (String localName, def map) throws XMLStreamException {
+		writer.writeEmptyElement(localName);
+		for (def key : map.keySet())
+			writeAttribute(key.toString(), map[key].toString());
+	}
+
+	@Override
+	public void writeEmptyElement(String namespaceURI, String localName)
+	throws XMLStreamException {
+		writer.writeEmptyElement(namespaceURI, localName);
+	}
+
+	@Override
+	public void writeEmptyElement (String prefix, String localName, String namespaceURI) throws XMLStreamException {
+		writer.writeEmptyElement(prefix, localName, namespaceURI);
+	}
+
+	@Override
+	public void writeEndDocument () throws XMLStreamException {
+		writer.writeEndDocument();
+	}
+
+	@Override
+	public void writeEndElement () throws XMLStreamException {
+		writer.writeEndElement();
+		events.pop()
+
+	}
+
+	@Override
+	public void writeEntityRef (String name) throws XMLStreamException {
+		writer.writeEntityRef(name);
+	}
+
+	@Override
+	public void writeNamespace(String prefix, String namespaceURI)
+	throws XMLStreamException {
+		writer.writeNamespace(prefix, namespaceURI);
+	}
+
+	@Override
+	public void writeProcessingInstruction(String target)
+	throws XMLStreamException {
+		writer.writeProcessingInstruction(target);
+	}
+
+	@Override
+	public void writeProcessingInstruction(String target, String data)
+	throws XMLStreamException {
+		writer.writeProcessingInstruction(target, data);
+	}
+
+	@Override
+	public void writeStartDocument () throws XMLStreamException {
+		writer.writeStartDocument();
+
+	}
+
+	@Override
+	public void writeStartDocument (String version) throws XMLStreamException {
+		writer.writeStartDocument(version);
+	}
+
+	@Override
+	public void writeStartDocument(String encoding, String version)
+	throws XMLStreamException {
+		writer.writeStartDocument(encoding, version);
+	}
+
+	@Override
+	public void writeStartElement (String localName) throws XMLStreamException {
+		writer.writeStartElement(localName);
+		events << localName
+
+	}
+	
+	public void writeStartElement (String localName, def map) throws XMLStreamException {
+		writeStartElement(localName);
+		for (def key : map.keySet()) {
+			writeAttribute(key.toString(), map[key].toString());
+		}
+	}
+
+	@Override
+	public void writeStartElement(String namespaceURI, String localName)
+	throws XMLStreamException {
+		writer.writeStartElement(namespaceURI, localName);
+		events << localName
+	}
+
+	@Override
+	public void writeStartElement(String prefix, String localName,
+	String namespaceURI) throws XMLStreamException {
+		writer.writeStartElement(prefix, localName, namespaceURI);
+		events << localName
+	}
+}
